1.1 Import Razorpay.framework library to Your Project
You can import the Razorpay iOS Custom SDK library using any of these ways: Cocoapod, Manual and Objective-C.Cocoapod
Refer to our Cocoapod pod.Manual
- Download the file and unzip the SDK attachment.
- Open your project in XCode and go to file under Menu and select Add files to “yourproject”.
- Select Razorpay.xcframework in the directory you just unzipped.
- Click on the Copy items if needed checkbox.
- Click Add.
Objective-C
If you are building an Objective-C project, follow the steps given for Swift and the additional steps given below:- Go to Project Settings and select Build Settings - All and Combined.
- Set the Always Embed Swift Standard Libraries option to TRUE.
Xcode 11
Ensure that you have the framework added in Frameworks, Libraries, and Embed Content under Target settings - General. ChangeEmbed status from - Do not Embed to Embed & Sign. Watch the GIF to see how to add Frameworks, Libraries and Embed Content.
1.2 Initialise Razorpay iOS Custom SDK
To initialise the Razorpay SDK:- API key. You can generate this from the Dashboard.
- A delegate that implements
RazorpayPaymentCompletionProtocolandWKNavigationDelegate - A
WKWebViewto show the bank pages
Initialise the Razorpay SDK only with API KeyTo render your UI based on the available payment methods, initialise the Razorpay SDK only with the API key and call getPaymentMethods.To use the SDK initialisation mentioned above, call the following method using the previously created Razorpay instance on any other page where you wish to initiate the payment through the authorise method.
1.3 Create an Order in Server
Order is an important step in the payment process.- An order should be created for every payment.
- You can create an order using the Orders API. It is a server-side API call. Know how to authenticate Orders API.
- The
order_idreceived in the response should be passed to the checkout. This ties the order with the payment and secures the request from being tampered.
API Sample Code
Use this endpoint to create an order using the Orders API.POST /orders
Request Parameters
Request Parameters
amount mandatory
: integer Payment amount in the smallest currency subunit. For example, if the amount is ₹500, enter 50000.currency mandatory
: string The currency in which the payment should be made by the customer. Length must be of 3 characters.receipt optional
: string Your receipt id for this order should be passed here. Maximum length is 40 characters.notes optional
: json object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.partial_payment optional
: boolean Indicates whether the customer can make a partial payment. Possible values:true: The customer can make partial payments.false(default): The customer cannot make partial payments.
first_payment_min_amount optional
: integer Minimum amount that must be paid by the customer as the first partial payment. For example, if an amount of ₹7000 is to be received from the customer in two installments of #1 - ₹5000, #2 - ₹2000 then you can set this value as 500000. This parameter should be passed only if partial_payment is true.Know more about Orders API.Response Parameters
Response Parameters
Descriptions for the response parameters are present in the Orders Entity parameters table.
Error Response Parameters
Error Response Parameters
The error response parameters are available in the API Reference Guide.
1.4 Get Payment Methods
You can accept payments through wallets, FPX, credit and debit cards depending on the methods enabled for your account. When you use Razorpay iOS Standard SDK, you do not have to handle the availability of different payment methods. However, when creating a custom checkout form, ensure the display of only the methods activated for your account to the customer. To get a list of available payment methods, callgetPaymentMethods. This fetches the list of payment methods asynchronously and returns the results.
1.5 Initiate Payment
Once you receive the required input from the customer, pass them to our SDK, which takes them to the appropriate authentication channel. Add the following code where you want to initiate payment:key mandatory
: string API Key ID generated from the Razorpay Dashboard.
amount mandatory
: integer The amount to be paid by the customer in currency subunits. For example, if the amount is ₹100, enter 10000.
currency mandatory
: string The currency in which the payment should be made by the customer.
description optional
: string Description of the product shown in the Checkout form. It must start with an alphanumeric character.
image optional
: string Link to an image (usually your business logo) shown in the Checkout form. Can also be a base64 string, if loading the image from a network is not desirable.
order_id mandatory
: string Order ID generated via the Orders API.
notes optional
: object Set of key-value pairs that can be used to store additional information about the payment. It can hold a maximum of 15 key-value pairs, each 256 characters long (maximum).
method mandatory
: string The payment method used by the customer on Checkout. Possible values:
card(default)fpx(default)wallet(default)
card mandatory if method=card
: object The details of the card that should be entered while making the payment.
number
: integer Unformatted card number.
name
: string The name of the cardholder.
expiry_month
: integer Expiry month for card in MM format.
expiry_year
: integer Expiry year for card in YY format.
cvv
: integer CVV printed on the back of the card.
bank mandatory if method=fpx
: string Bank code. List of available banks enabled for your account can be fetched via methods.
wallet mandatory if method=wallet
: string Wallet code for the wallet used for the payment. Possible values:
touchngo(default)grabpay(default)shopback(requires approval)
callback_url optional
: string Customers will be redirected to this URL on successful payment. Ensure that the domain of the Callback URL is whitelisted. This parameter is mandatory for FPX payments.
redirect optional
: boolean Determines whether to post a response to the event handler post payment completion or redirect to Callback URL. callback_url and redirect parameters are mandatory for FPX payments. Possible values:
true: Customer is redirected to the specified callback URL in case of payment failure. For FPX payments, theredirectparameter should always be sent astrue.false(default): Customer is not redirected to the specified callback URL.
Handy TipsThe
notes field is a read-only field associated with payment and is returned while fetching payment details. Razorpay Curlec cannot modify this field. You can add up to 15 notes that will then be associated with the payment. For example: "notes[internal_key_1]", "notes[internal_key_2]"). Razorpay Curlec returns this when you fetch payment details from the API.1.6 Pass WKNavigationDelegate actions to SDK
SDK handles the responses from WKWebView to give you the correct status of the payment.1.7 Handle Success and Error Events
This is done by implementing theonPaymentSuccess and onPaymentError methods of the RazorpayPaymentCompletionProtocol.
We recommend giving the user an option to cancel the payment midway and pass on this action. You may also implement a retry action or display a relevant message at this step based on your use case.
payment_id that you can use later to capture the payment.
1.8 Store the Fields in Server
A successful payment returns the following fields to the Checkout form.Success Callback
Success Callback
- You need to store these fields in your server.
- You can confirm the authenticity of these details by verifying the signature in the next step.
razorpay_payment_id
: string Unique identifier for the payment returned by Checkout only for successful payments.razorpay_order_id
: string Unique identifier for the order returned by Checkout.razorpay_signature
: string Signature returned by the Checkout. This is used to verify the payment.1.9 Verify Payment Signature
This is a mandatory step to confirm the authenticity of the details returned to the Checkout form for successful payments.To verify the razorpay_signature returned to you by the Checkout form:
To verify the razorpay_signature returned to you by the Checkout form:
-
Create a signature in your server using the following attributes:
order_id: Retrieve theorder_idfrom your server. Do not use therazorpay_order_idreturned by Checkout.razorpay_payment_id: Returned by Checkout.key_secret: Available in your server. Thekey_secretthat was generated from the Dashboard.
-
Use the SHA256 algorithm, the
razorpay_payment_idand theorder_idto construct a HMAC hex digest as shown below:
HMAC Hex Digest
- If the signature you generate on your server matches the
razorpay_signaturereturned to you by the Checkout form, the payment received is from an authentic source.
Generate Signature on Your Server
Generate Signature on Your Server
Given below is the sample code for payment signature verification:
Post Signature Verification
Post Signature Verification
After you have completed the integration, you can set up webhooks, make test payments, replace the test key with the live key and integrate with other APIs.
1.10 Verify Payment Status
Handy TipsOn the Razorpay Dashboard, ensure that the payment status is
captured. Refer to the payment capture settings page to know how to capture payments automatically.You can track the payment status in three ways:
You can track the payment status in three ways:
- Verify Status from Dashboard
- Subscribe to Webhook Events
- Poll APIs
To verify the payment status from the Razorpay Dashboard:
- Log in to the Razorpay Dashboard and navigate to Transactions → Payments.
- Check if a Payment Id has been generated and note the status. In case of a successful payment, the status is marked as Captured.
